package j2d.filters.bufferedImageConvolution;

import j2d.ImageUtils;

import java.awt.*;

import math.fourierTransforms.r2.FFT2dComplex;


public class FFTR2ImageConvolver implements ImageMatrixBeanProcessorInterface {
    private ImageMatrixBean imb;


    public Image process(Image image) {
        image = ImageUtils.cropImageToIntegralPowerOfTwo(image);
        final int w = image.getWidth(null);
        final int h = image.getHeight(null);
        Image kernalImage = imb.getImage(w, h);
        FFT2dComplex f1 = new FFT2dComplex(image);
        FFT2dComplex f2 = new FFT2dComplex(kernalImage);

        f1.fft();
        f2.fft();

        f1.mult(f2);
        f1.ifft();

        return ImageUtils.quadSwap(f1.getScaledImage());
    }

    public FFTR2ImageConvolver(ImageMatrixBean o) {
        this.imb = o;
    }

    public void setImageMatrixBean(ImageMatrixBean imb) {
        this.imb = imb;
    }

    public ImageMatrixBean getImageMatrixBean() {
        return imb;
    }

    public String toString() {
        return "FFTR2";
    }
}

